<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUserDefinedText ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUserDefinedText
 * @subpackage Arrays
 */
class ArrayOfUserDefinedText extends AbstractStructArrayBase
{
    /**
     * The UserDefinedText
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UserDefinedText[]
     */
    public $UserDefinedText;
    /**
     * Constructor method for ArrayOfUserDefinedText
     * @uses ArrayOfUserDefinedText::setUserDefinedText()
     * @param \StructType\UserDefinedText[] $userDefinedText
     */
    public function __construct(array $userDefinedText = array())
    {
        $this
            ->setUserDefinedText($userDefinedText);
    }
    /**
     * Get UserDefinedText value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UserDefinedText[]|null
     */
    public function getUserDefinedText()
    {
        return isset($this->UserDefinedText) ? $this->UserDefinedText : null;
    }
    /**
     * Set UserDefinedText value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UserDefinedText[] $userDefinedText
     * @return \ArrayType\ArrayOfUserDefinedText
     */
    public function setUserDefinedText(array $userDefinedText = array())
    {
        foreach ($userDefinedText as $arrayOfUserDefinedTextUserDefinedTextItem) {
            // validation for constraint: itemType
            if (!$arrayOfUserDefinedTextUserDefinedTextItem instanceof \StructType\UserDefinedText) {
                throw new \InvalidArgumentException(sprintf('The UserDefinedText property can only contain items of \StructType\UserDefinedText, "%s" given', is_object($arrayOfUserDefinedTextUserDefinedTextItem) ? get_class($arrayOfUserDefinedTextUserDefinedTextItem) : gettype($arrayOfUserDefinedTextUserDefinedTextItem)), __LINE__);
            }
        }
        if (is_null($userDefinedText) || (is_array($userDefinedText) && empty($userDefinedText))) {
            unset($this->UserDefinedText);
        } else {
            $this->UserDefinedText = $userDefinedText;
        }
        return $this;
    }
    /**
     * Add item to UserDefinedText value
     * @throws \InvalidArgumentException
     * @param \StructType\UserDefinedText $item
     * @return \ArrayType\ArrayOfUserDefinedText
     */
    public function addToUserDefinedText(\StructType\UserDefinedText $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UserDefinedText) {
            throw new \InvalidArgumentException(sprintf('The UserDefinedText property can only contain items of \StructType\UserDefinedText, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->UserDefinedText[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UserDefinedText|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UserDefinedText|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UserDefinedText|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UserDefinedText|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UserDefinedText|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UserDefinedText
     */
    public function getAttributeName()
    {
        return 'UserDefinedText';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfUserDefinedText
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
