<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerInputData StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:CustomerInputData
 * @subpackage Structs
 */
class CustomerInputData extends CustomerData
{
    /**
     * The IsProspect
     * Meta informations extracted from the WSDL
     * - documentation: [Added 2016/11 - V1201] [Optional] - ??? Propriété indiquant si le client est un prospect. ??? - Related to column CBR [TIERS.T_NATUREAUXI].
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $IsProspect;
    /**
     * Constructor method for CustomerInputData
     * @uses CustomerInputData::setIsProspect()
     * @param bool $isProspect
     */
    public function __construct($isProspect = null)
    {
        $this
            ->setIsProspect($isProspect);
    }
    /**
     * Get IsProspect value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getIsProspect()
    {
        return isset($this->IsProspect) ? $this->IsProspect : null;
    }
    /**
     * Set IsProspect value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $isProspect
     * @return \StructType\CustomerInputData
     */
    public function setIsProspect($isProspect = null)
    {
        if (is_null($isProspect) || (is_array($isProspect) && empty($isProspect))) {
            unset($this->IsProspect);
        } else {
            $this->IsProspect = $isProspect;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CustomerInputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
